document.addEventListener('DOMContentLoaded', async () => {
    const input = document.getElementById('apiKeyInput');
    const status = document.getElementById('status');
  
    // Load stored key if exists
    chrome.storage.local.get(['apiKey'], (result) => {
      if (result.apiKey) {
        input.value = result.apiKey;
        status.textContent = 'Current key loaded.';
      }
    });
  
    document.getElementById('saveBtn').addEventListener('click', () => {
      const apiKey = input.value.trim();
  
      if (!apiKey) {
        status.textContent = '❌ Please enter a valid API key.';
        return;
      }
  
      chrome.storage.local.set({ apiKey }, () => {
        status.textContent = '✅ API key saved successfully!';
      });
    });
  });
  