// background.js
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    if (message.type === 'SAVE_SYMBOL') {
      chrome.storage.local.set({ currentSymbol: message.symbol }, () => {
        console.log('Background: Saved symbol', message.symbol);
        sendResponse({ success: true }); // ✅ Respond back
      });
      return true; // ✅ Tell Chrome to keep the message port open
    }
  });
// background.js
chrome.tabs.onUpdated.addListener((tabId, changeInfo, tab) => {
    if (changeInfo.status === 'complete' && tab.url && tab.url.includes('tradingview.com')) {
      chrome.scripting.executeScript({
        target: { tabId: tabId },
        files: ['content.js']
      }).then(() => {
        console.log('✅ Reinjected content script after SPA navigation.');
      }).catch((err) => {
        console.error('⚠️ Failed to reinject:', err);
      });
    }
  });

  chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    if (message.type === 'SAVE_SYMBOL') {
      chrome.storage.local.set({ currentSymbol: message.symbol }, () => {
        sendResponse({ success: true });
      });
      return true;
    }
  
    if (message.type === 'SAVE_TRADE') {
      chrome.storage.local.get(['trades'], (result) => {
        const trades = result.trades || [];
        trades.push(message.trade);
        chrome.storage.local.set({ trades }, () => {
          console.log('Background: Trade saved.');
          sendResponse({ success: true });
        });
      });
      return true;
    }
  });

  chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    // handle message
    sendResponse({ success: true }); // Always call sendResponse if you expect a response
    return true; // If you want to respond asynchronously
  });
  
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
  if (request.type === 'CAPTURE_VISIBLE_TAB') {
    chrome.tabs.captureVisibleTab(null, { format: 'png' }, (dataUrl) => {
      if (chrome.runtime.lastError) {
        sendResponse({ error: chrome.runtime.lastError.message });
      } else {
        // Crop the image to the requested area
        const img = new Image();
        img.onload = () => {
          const canvas = document.createElement('canvas');
          const ctx = canvas.getContext('2d');
          const { width, height, top, left } = request.area;
          
          canvas.width = width;
          canvas.height = height;
          
          // Draw the cropped portion
          ctx.drawImage(
            img,
            left, top, width, height,  // Source rectangle
            0, 0, width, height        // Destination rectangle
          );
          
          sendResponse({ imageData: canvas.toDataURL('image/png') });
        };
        img.onerror = () => {
          sendResponse({ error: 'Failed to process image' });
        };
        img.src = dataUrl;
      }
    });
    return true; // Required for async sendResponse
  }
});
  